/**
 * @license
 *-------------------------------------------------------------------------------------------
 * Copyright © 2025 Progress Software Corporation. All rights reserved.
 * Licensed under commercial license. See LICENSE.md in the package root for more information
 *-------------------------------------------------------------------------------------------
 */
"use strict";Object.defineProperty(exports,Symbol.toStringTag,{value:"Module"});const At=require("react"),L=require("prop-types"),o=require("@progress/kendo-react-common"),Ht=require("@progress/kendo-react-labels"),Bt=require("@progress/kendo-svg-icons"),Wt=require("../common/ListContainer.js"),_t=require("../common/ListFilter.js"),et=require("../common/GroupStickyHeader.js"),Ut=require("../common/ListDefaultItem.js"),Gt=require("../common/List.js"),tt=require("../common/DropDownBase.js"),d=require("../common/utils.js"),jt=require("../package-metadata.js"),$t=require("@progress/kendo-react-buttons"),Yt=require("@progress/kendo-react-intl"),$=require("../messages/index.js"),Jt=require("@progress/kendo-react-layout"),Qt=require("../common/AdaptiveMode.js");function Rt(N){const Y=Object.create(null,{[Symbol.toStringTag]:{value:"Module"}});if(N){for(const T in N)if(T!=="default"){const n=Object.getOwnPropertyDescriptor(N,T);Object.defineProperty(Y,T,n.get?n:{enumerable:!0,get:()=>N[T]})}}return Y.default=N,Object.freeze(Y)}const i=Rt(At),Xt="Please select a value from the list!",pe=i.forwardRef((N,Y)=>{let T=!1;const n=o.usePropsContext(nt,N),{delay:rt=P.delay,tabIndex:ot=P.tabIndex,ignoreCase:me=P.ignoreCase,size:O=P.size,rounded:Me=P.rounded,fillMode:ge=P.fillMode,groupMode:Zt=P.groupMode}=n;if(n.filterable||n.virtual){const e=[];n.filterable&&e.push("filterable"),n.virtual&&e.push("virtualization"),T=!o.validatePackage(jt.packageMetadata,{component:"DropDownList",features:e})}const b=o.useUnstyled(),fe=o.useId(n.id),ve=()=>{var e;if(o.canUseDOM)return((e=Q.current)==null?void 0:e.ownerDocument)||window.document},st=()=>{var e,r;(e=t==null?void 0:t.current)!=null&&e.wrapper&&((r=t==null?void 0:t.current)==null||r.wrapper.focus({preventScroll:!0}))},k=()=>{let e;return z.current!==void 0&&z.current!==null?e=z.current:n.value!==void 0?e=n.value:g.value!==void 0&&g.value!==null?e=g.value:n.defaultValue!==void 0&&n.defaultValue!==null&&(e=n.defaultValue),!d.isPresent(e)&&n.defaultItem!==void 0&&n.defaultItem!==null&&(e=n.defaultItem),e},at=()=>{const{dataItemKey:e}=n,r=d.getFilteredData(n),s=k();return r.findIndex(c=>d.areSame(c,s,e))},ye=()=>n.required!==void 0?n.required:P.required,De=()=>{const e=n.validationMessage!==void 0,r=k(),s=!ye()||r!==null&&r!==""&&r!==void 0,c=n.valid!==void 0?n.valid:s;return{customError:e,valid:c,valueMissing:r===null}},it=()=>n.validityStyles!==void 0?n.validityStyles:P.validityStyles,ne=e=>{re.current=!0,e.focus(),window.setTimeout(()=>re.current=!1,30)},Ie=()=>{R.current&&ne(R.current),n.adaptive&&setTimeout(()=>{R.current&&ne(R.current)},300)},lt=i.useCallback(e=>{for(const r of e)bt(r.target.clientWidth)},[]),Ne=()=>{var e;(e=xe.current)!=null&&e.setCustomValidity&&xe.current.setCustomValidity(De().valid?"":n.validationMessage||Xt)},W=(e,r)=>{const s=k();d.areSame(s,e,n.dataItemKey)||(n.value===void 0&&(r.data.value=e),t.current.updateComponentArgs({value:e}),z.current=e,r.events.push({type:"onChange"}))},E=e=>{var r;(r=t==null?void 0:t.current)==null||r.applyState(e),z.current=void 0},J=(e,r)=>{var p;const{virtual:s,dataItemKey:c,defaultItem:u}=n,m=d.getFilteredData(n),y=s?s.skip:0,f=k(),a=e===-1&&u!==void 0?u:m[e-y],v=!d.areSame(a,f,c);W(a,r),v&&((p=t==null?void 0:t.current)==null||p.triggerPageChangeCornerItems(a,r))},q=(e,r,s)=>{var x,I;const{defaultItem:c,dataItemKey:u,virtual:m={skip:0,total:0,pageSize:0}}=n,y=k(),f=d.getFilteredData(n),a=(x=t==null?void 0:t.current)==null?void 0:x.vs,v=f.findIndex(h=>d.areSame(h,y,u)),p=(I=t==null?void 0:t.current)==null?void 0:I.navigation.navigate({current:m.skip+v,max:(a!=null&&a.enabled?m.total:f.length)-1,min:c!==void 0?-1:0,keyCode:r,skipItems:s||void 0});p!==void 0&&J(p,e),E(e)},dt=e=>{Q.current=e,t.current.wrapper=e},ct=e=>i.createElement("select",{name:n.name,ref:r=>{xe.current=r},tabIndex:-1,"aria-hidden":!0,title:n.label,style:{opacity:0,width:1,border:0,zIndex:-1,position:"absolute",left:"50%"}},i.createElement("option",{value:n.valueMap?n.valueMap.call(void 0,e):e})),we=()=>{const{textField:e,dataItemKey:r,virtual:s={skip:0},focusedItemIndex:c=d.itemIndexStartsWith,filterable:u,skipDisabledItems:m=!0}=n,y=k(),f=d.getFilteredData(n),a=n.filter?n.filter:g.text;return m&&e&&!a&&!y?f.findIndex(v=>!v.disabled&&v[e]):d.isPresent(y)&&a===void 0||u&&a===""?f.findIndex(v=>d.areSame(v,y,r)):a?Ce.current?c(f,a,e):f.findIndex(v=>d.areSame(v,y,r)):s.skip===0?0:-1},Te=(e,r)=>r!==void 0&&r!==-1&&e&&e.length>0&&e[r].disabled,he=()=>{const e=d.getFilteredData(n),r=t.current.initState(),s=we();Te(e,s)&&(W(null,r),E(r))},Se=e=>{if(e.isPropagationStopped())return;const r=t.current.initState();r.syntheticEvent=e,g.focused||(r.data.focused=!0),he(),t.current.togglePopup(r),E(r)},Oe=e=>{var M,ce,B,ue,j,Xe,Ze;e&&e.target instanceof Element&&e.target.nodeName==="INPUT"&&e.stopPropagation&&e.stopPropagation();const{filterable:r,disabled:s,defaultItem:c,leftRightKeysNavigation:u=!0,virtual:m={skip:0,total:0,pageSize:0},dataItemKey:y,groupField:f="",textField:a,skipDisabledItems:v=!0}=n,p=d.getFilteredData(n),x=k(),I=p.findIndex(C=>d.areSame(C,x,y)),h=n.opened!==void 0?n.opened:g.opened,l=e.keyCode,F=l===o.Keys.home||l===o.Keys.end,K=l===o.Keys.up||l===o.Keys.down,G=!h&&(e.altKey&&l===o.Keys.down||l===o.Keys.enter||l===o.Keys.space),te=h&&(e.altKey&&l===o.Keys.up||l===o.Keys.esc),le=u&&(l===o.Keys.left||l===o.Keys.right),de=K||le&&!r||F,S=t.current.initState();if(S.syntheticEvent=e,!s){if(F&&((M=t==null?void 0:t.current)!=null&&M.vs.enabled))l===o.Keys.home?m.skip!==0?((ce=t==null?void 0:t.current)==null||ce.triggerOnPageChange(S,0,m.pageSize),V.current=!0):W(p[0],S):m.skip<m.total-m.pageSize?((B=t==null?void 0:t.current)==null||B.triggerOnPageChange(S,m.total-m.pageSize,m.pageSize),V.current=!0):W(p[p.length-1],S);else if(h&&l===o.Keys.pageUp)e.preventDefault(),(ue=t==null?void 0:t.current)==null||ue.scrollPopupByPageSize(-1);else if(h&&l===o.Keys.pageDown)e.preventDefault(),(j=t==null?void 0:t.current)==null||j.scrollPopupByPageSize(1);else if(h&&l===o.Keys.enter){const C=we();Te(p,C)?(W(null,S),E(S)):J(C,S),(Xe=t==null?void 0:t.current)==null||Xe.togglePopup(S),e.preventDefault()}else if(G||te)te&&he(),(Ze=t==null?void 0:t.current)==null||Ze.togglePopup(S),e.preventDefault();else if(de){if(Ce.current=!1,f!==""&&a)if(!v&&h)q(S,l);else{let C;if(l===o.Keys.down||l===o.Keys.right){const w=p.slice(I+1).find(D=>!D.disabled&&D[a]);C=w&&p.findIndex(D=>D[a]===w[a])}else if(l===o.Keys.up||l===o.Keys.left){let w;if(I===0&&c)C=-1;else if(I===-1)w=p,C=p.findIndex(D=>!D.disabled&&D[a]);else{w=p.slice(0,I);let D=w.pop();for(;D&&D.disabled;)D=w.pop();C=D&&p.findIndex(Pe=>Pe[a]===D[a])}}if(C!==void 0){const w=C-I;q(S,l,w)}else C===void 0&&p.findIndex(w=>w[a]===x[a])===p.length-1&&q(S,l)}else if(!v&&h||F)q(S,l);else if(a){let C;if(l===o.Keys.down||l===o.Keys.right){const w=p.slice(I+1).find(D=>!D.disabled&&D[a]);C=w&&p.findIndex(D=>D[a]===w[a])}else if(l===o.Keys.up||l===o.Keys.left){let w;if(I===0&&c)C=-1;else if(I===-1)w=p,C=p.find(D=>!D.disabled&&D[a]);else{w=p.slice(0,I);let D=w.pop();for(;D&&D.disabled;)D=w.pop();C=D&&p.findIndex(Pe=>Pe[a]===D[a])}}if(C!==void 0){const w=C-I;q(S,l,w)}else C===void 0&&p.findIndex(w=>w[a]===x[a])===p.length-1&&q(S,l)}else q(S,l);e.preventDefault()}E(S)}},ut=e=>{const r=t.current.initState();r.syntheticEvent=e.syntheticEvent,n.filter===void 0&&(r.data.text=e.target.value),t.current.filterChanged(e.target.value,r),Ce.current=!0,E(r),Z({group:void 0,text:String(e.target.value)})},qe=e=>{const r=n.filter!==void 0?n.filter:g.text;return n.filterable&&i.createElement(_t,{value:r,ref:s=>{R.current=s&&s.element},onChange:ut,onKeyDown:Oe,size:e?"large":O,rounded:Me,fillMode:ge,renderListFilterWrapper:!0,placeholder:We.toLanguageString($.dropDownListAdaptiveFilterPlaceholder,$.messages[$.dropDownListAdaptiveFilterPlaceholder])})},pt=e=>{var s;const r=t.current.initState();r.syntheticEvent=e,(s=t==null?void 0:t.current)==null||s.togglePopup(r),W(n.defaultItem,r),E(r)},mt=()=>{const{textField:e,defaultItem:r,dataItemKey:s}=n,c=k();return r!==void 0&&i.createElement(Ut,{defaultItem:r,textField:e,selected:d.areSame(c,r,s),key:"defaultitemkey",onClick:pt})},gt=(e,r)=>{var s;(s=t==null?void 0:t.current)==null||s.handleItemClick(e,r),z.current=void 0},ft=e=>{const{vs:r,list:s}=t.current;r.scrollHandler(e);const{groupField:c}=n;let u=d.getFilteredData(n);if(!(!c||!u.length)&&c){const m=He.current=He.current||(r.enabled?r.itemHeight:s?s.children[0].offsetHeight:0),f=e.target.scrollTop-r.skip*m;u=t.current.getGroupedDataModernMode(u,c);let a=u[0][c];for(let v=1;v<u.length&&!(m*v>f);v++)u[v]&&u[v][c]&&(a=u[v][c]);a!==g.group&&Z({group:a})}},ze=()=>{var l;const{textField:e,dataItemKey:r,virtual:s={skip:0,total:void 0},groupHeaderItemRender:c,listNoDataRender:u,itemRender:m}=n,y=d.getFilteredData(n),f=b&&b.uDropDownList,a=t.current.vs,v=s.skip,p=n.opened!==void 0?n.opened:g.opened,x=t.current.getPopupSettings(),I=`translateY(${a.translate}px)`,h=k();return i.createElement(Gt,{id:Ke,show:p,data:y.slice(),focusedIndex:we(),value:h,textField:e,valueField:r,optionsGuid:Ue,groupField:n.groupField,groupMode:"modern",listRef:F=>{a.list=t.current.list=F},wrapperStyle:{maxHeight:U?void 0:x.height},wrapperCssClass:o.classNames(o.uDropDownList.listContent({c:f})),listStyle:a.enabled?{transform:I}:void 0,key:"listkey",skip:v,onClick:gt,itemRender:m,groupHeaderItemRender:c,noDataRender:u,onScroll:ft,wrapperRef:a.scrollerRef,scroller:(l=t==null?void 0:t.current)==null?void 0:l.renderScrollElement(),ariaSetSize:s.total})},vt=()=>{const{groupField:e}=n,r=d.getFilteredData(n),s=n.opened!==void 0?n.opened:g.opened,c=b&&b.uDropDownList,u={title:n.adaptiveTitle||n.label,subTitle:n.adaptiveSubtitle,expand:s,onClose:y=>Se(y),windowWidth:ke,mobileFilter:qe(!0)};let{group:m}=g;return m===void 0&&e!==void 0&&(m=d.getItemValue(r[0],e)),i.createElement(Qt.AdaptiveMode,{...u},i.createElement(Jt.ActionSheetContent,null,i.createElement("div",{className:o.classNames(o.uDropDownList.listContainer({c,popup:!1}))},wt())))},yt=()=>{g.focused&&window.setTimeout(()=>{g.focused&&t.current.wrapper&&ne(t.current.wrapper)})},Dt=e=>{"onMouseDownOutside"in(n.popupSettings||{})&&n.popupSettings.onMouseDownOutside.call(void 0,e)},It=()=>{const{header:e,footer:r,dir:s,groupField:c,groupStickyHeaderItemRender:u,list:m}=n,y=d.getFilteredData(n),f=t.current,a=f.getPopupSettings(),v=n.opened!==void 0?n.opened:g.opened,p=a.width!==void 0?a.width:f.popupWidth,x=b&&b.uDropDownList,I={dir:s!==void 0?s:f.dirCalculated,width:p,popupSettings:{...a,popupClass:o.classNames(a.popupClass,o.uDropDownList.listContainer({c:x,popup:!0})),anchor:a.anchor||Q.current,show:v,onOpen:Ie,onClose:yt,onMouseDownOutside:Dt},itemsCount:[y.length]};let{group:h}=g;return h===void 0&&c!==void 0&&(h=d.getItemValue(y[0],c)),i.createElement(Wt,{...I},qe(!1),e&&i.createElement("div",{className:o.classNames(o.uDropDownList.listHeader({c:x}))},e),i.createElement("div",{className:o.classNames(o.uDropDownList.list({c:x,size:O,virtual:t.current.vs.enabled}))},mt(),!m&&h&&y.length!==0&&i.createElement(et,{group:h,groupMode:"modern",render:u}),ze()),r&&i.createElement("div",{className:o.classNames(o.uDropDownList.listFooter({c:x}))},r),T&&i.createElement(o.WatermarkOverlay,null))},wt=()=>{const{header:e,footer:r,groupStickyHeaderItemRender:s,groupField:c,list:u}=n,m=d.getFilteredData(n),y=b&&b.uDropDownList;let{group:f}=g;return f===void 0&&c!==void 0&&(f=d.getItemValue(m[0],c)),i.createElement(i.Fragment,null,e&&i.createElement("div",{className:o.classNames(o.uDropDownList.listHeader({c:y}))},e),i.createElement("div",{className:o.classNames("k-list",{[`k-list-${U?"lg":o.sizeMap[O]||O}`]:O})},!u&&f&&m.length!==0&&i.createElement(et,{group:f,groupMode:"modern",render:s}),ze()),r&&i.createElement("div",{className:"k-list-footer"},r))},ht=e=>{const{dataItemKey:r}=n,s=d.getFilteredData(n),c=k();let u=s.map((K,G)=>({item:K,itemIndex:G}));const m=_.current.word,y=_.current.last,f=d.sameCharsOnly(m,y);let a=u.length,v=Math.max(0,s.findIndex(K=>d.areSame(K,c,r))),p;n.defaultItem&&(p={item:n.defaultItem,itemIndex:-1},a+=1,v+=1),v+=f?1:0,u=d.shuffleData(u,v,p);let x,I,h,l=0;const{textField:F}=n;for(;l<a;){if(x=d.getItemValue(u[l].item,F),I=f&&d.matchText(x,y,me),h=d.matchText(x,m,me),I||h){l=u[l].itemIndex;break}l++}if(l!==a){const K=t.current.initState();K.syntheticEvent=e,J(l,K),E(K),z.current=void 0}},St=e=>{clearTimeout(Ae.current),n.filterable||(Ae.current=window.setTimeout(()=>_.current.word="",rt),ht(e))},xt=e=>{re.current||t.current.handleFocus(e)},Ct=e=>{if(re.current||!g.focused)return;const r=n.opened!==void 0?n.opened:g.opened,s=t.current.initState();s.syntheticEvent=e,s.data.focused=!1,s.events.push({type:"onBlur"}),r&&he(),r&&!U&&t.current.togglePopup(s),E(s)},Lt=e=>{if(n.filterable||e.which===0||e.keyCode===o.Keys.enter)return;let r=String.fromCharCode(e.charCode||e.keyCode);me&&(r=r.toLowerCase()),r===" "&&e.preventDefault(),_.current={word:_.current.word+r,last:_.current.last+r},St(e)},kt=()=>{const e=t.current.initState();e.data.opened=g.opened,t.current.togglePopup(e),E(e)},Ve=i.useRef(null),Q=i.useRef(null),xe=i.useRef(null),R=i.useRef(null);i.useImperativeHandle(Ve,()=>({get element(){return Q.current},get index(){return at()},get name(){return n.name},get validity(){return De()},get value(){return k()},get focused(){return g.focused},get opened(){return g.opened},focus:st,props:n,togglePopup:kt})),i.useImperativeHandle(Y,()=>Ve.current);const Ae=i.useRef(null),_=i.useRef({word:"",last:""}),re=i.useRef(!1),z=i.useRef(null),V=i.useRef(!1),Ce=i.useRef(!1),A=i.useRef({}),Le=i.useRef({}),t=i.useRef(new tt({props:n,setState:()=>{},state:{},forceUpdate:()=>{},element:null,value:null,handleItemSelect:()=>{}})),He=i.useRef(0),X=i.useRef(null),[g,Kt]=i.useState({}),[ke,bt]=i.useState(),[,Be]=i.useReducer(e=>e,!0),We=Yt.useLocalization(),Z=e=>{Kt({...g,...e})};i.useEffect(()=>{t.current.updateComponentArgs({props:n,setState:Z,state:g,forceUpdate:Be,element:Q.current,handleItemSelect:J,value:k()})},[Z,g,Be,J,k]),i.useEffect(()=>{var v,p,x,I,h,l,F,K,G,te,le,de,S;const{dataItemKey:e,virtual:r,groupField:s="",textField:c}=n,u=d.getFilteredData(n),m=A.current.virtual?A.current.virtual.total:0,y=n.opened!==void 0?n.opened:g.opened,f=A.current.opened!==void 0?A.current.opened:Le.current.opened,a=!f&&y;if((v=t==null?void 0:t.current)==null||v.didUpdate(),(p=t==null?void 0:t.current)!=null&&p.getPopupSettings().animate||a&&Ie(),r&&r.total!==m)(x=t==null?void 0:t.current)==null||x.vs.calcScrollElementHeight(),(I=t==null?void 0:t.current)==null||I.vs.reset();else{const M=k(),ce=A.current.value!==void 0?A.current.value:Le.current.value;let B=u.findIndex(j=>d.areSame(j,M,e));s!==""&&M&&c&&(B=(l=(h=t==null?void 0:t.current)==null?void 0:h.getGroupedDataModernMode(u,s))==null?void 0:l.map(j=>j[c]).indexOf(M[c]));const ue=!d.areSame(ce,M,e);a&&r?(F=t==null?void 0:t.current)==null||F.scrollToVirtualItem(r,B):a&&!r?(Ie(),u&&u.length!==0&&((K=t==null?void 0:t.current)==null||K.resetGroupStickyHeader(u[0][s],{setState:Z,group:g.group,state:g})),(G=t==null?void 0:t.current)==null||G.scrollToItem(B)):y&&f&&M&&ue&&!V.current?(le=t==null?void 0:t.current)==null||le.scrollToItem(B,(te=t==null?void 0:t.current)==null?void 0:te.vs.enabled):y&&f&&V.current&&(V.current&&r&&r.skip===0?(de=t==null?void 0:t.current)==null||de.vs.reset():V.current&&r&&r.skip===r.total-r.pageSize&&((S=t==null?void 0:t.current)==null||S.vs.scrollToEnd()))}V.current=!1,Le.current=g,A.current=n,Ne()}),i.useEffect(()=>{var e,r;return X.current=o.canUseDOM&&window.ResizeObserver&&new window.ResizeObserver(lt.bind(void 0)),(e=t==null?void 0:t.current)==null||e.didMount(),Ne(),(r=ve())!=null&&r.body&&X.current&&X.current.observe(ve().body),()=>{var s;(s=ve())!=null&&s.body&&X.current&&X.current.disconnect()}},[]);const _e=fe+"-accessibility-id",Ke=fe+"-listbox-id",Ue=fe+"-guid",Et=We.toLanguageString($.dropDownListArrowBtnAriaLabel,$.messages[$.dropDownListArrowBtnAriaLabel]),{style:oe,className:Ft,label:be,dir:Pt,virtual:H,adaptive:en,dataItemKey:Mt,disabled:se,loading:Ge,iconClassName:je,svgIcon:Nt,valueRender:$e}=n,Ee=n.opened!==void 0?n.opened:g.opened,ae=k(),Fe=d.getItemValue(ae,n.textField),Ye=!it()||De().valid,ie=t.current,Tt=ie.vs,ee=b&&b.uDropDownList;Tt.enabled=H!==void 0;const Je=o.useAdaptiveModeContext(),U=!!(ke&&Je&&ke<=Je.medium&&n.adaptive);H!==void 0&&(ie.vs.skip=H.skip,ie.vs.total=H.total,ie.vs.pageSize=H.pageSize);const Ot=d.getFilteredData(n),{focused:qt}=g,zt=Ot.findIndex(e=>d.areSame(e,ae,Mt)),Qe=i.createElement("span",{id:_e,className:o.classNames(o.uDropDownList.inputInner({c:ee}))},Fe&&i.createElement("span",{className:o.classNames(o.uDropDownList.inputText({c:ee}))},Fe)),Vt=$e!==void 0?$e.call(void 0,Qe,ae):Qe,Re=i.createElement(i.Fragment,null,i.createElement("span",{ref:dt,className:o.classNames(o.uDropDownList.wrapper({c:ee,size:O,rounded:Me,fillMode:ge,focused:qt,disabled:se,invalid:!Ye,loading:Ge,required:ye()}),Ft),style:be?{...oe,width:void 0}:oe,dir:Pt,onMouseDown:Ee?e=>{e.target.nodeName!=="INPUT"&&(ne(t.current.wrapper),e.preventDefault())}:void 0,onFocus:U?e=>Se(e):xt,onBlur:Ct,tabIndex:o.getTabIndex(ot,se),accessKey:n.accessKey,onKeyDown:Oe,onKeyPress:Lt,onClick:se?void 0:Se,role:"combobox","aria-required":ye(),"aria-disabled":se||void 0,"aria-haspopup":"listbox","aria-expanded":Ee||!1,"aria-owns":Ke,"aria-activedescendant":Ee?"option-"+Ue+"-"+(zt+(H?H.skip:0)):void 0,"aria-label":n.ariaLabel||n.label,"aria-labelledby":n.ariaLabelledBy,"aria-describedby":n.ariaDescribedBy||_e,"aria-controls":Ke,id:n.id,title:n.title},Vt,Ge&&i.createElement(o.IconWrap,{className:o.classNames(o.uDropDownList.loadingIcon({c:ee})),name:"loading"}),i.createElement($t.Button,{tabIndex:-1,type:"button","aria-label":Et,size:O,fillMode:ge,className:o.classNames(o.uDropDownList.inputButton({c:ee})),rounded:null,themeColor:"base",iconClass:je,svgIcon:je?void 0:Nt||Bt.caretAltDownIcon,onMouseDown:e=>g.focused&&e.preventDefault()}),ct(ae),!U&&It()),U&&vt());return be?i.createElement(Ht.FloatingLabel,{label:be,editorValue:Fe,editorValid:Ye,editorDisabled:n.disabled,style:{width:oe?oe.width:void 0},children:Re}):Re});pe.propTypes={delay:L.number,ignoreCase:L.bool,iconClassName:L.string,svgIcon:o.svgIconPropType,defaultItem:L.any,valueRender:L.func,valueMap:L.func,validationMessage:L.string,required:L.bool,id:L.string,ariaLabelledBy:L.string,ariaDescribedBy:L.string,ariaLabel:L.string,leftRightKeysNavigation:L.bool,title:L.string,groupField:L.string,list:L.any,skipDisabledItems:L.bool};const P={delay:500,tabIndex:0,ignoreCase:!0,...tt.defaultProps,required:!1,size:"medium",rounded:"medium",fillMode:"solid",groupMode:"modern"};pe.displayName="KendoReactDropDownList";const nt=o.createPropsContext();pe.displayName="KendoReactDropDownList";exports.DropDownList=pe;exports.DropDownListPropsContext=nt;exports.dropDownListDefaultProps=P;
